#include <iostream>
#include <string>

unsigned generateId() {
	static unsigned last = 0;
	return last++;
}

class Person {
	std::string name;
	const unsigned id;

public:
	Person(const std::string& name)
	    : name(name)
	    , id(generateId()) {}

	Person(const Person& other)
	    : name(other.name)
	    , id(generateId()) {}

	Person& operator=(const Person& other) {
		name = other.name;
		// id not changed!
		return *this;
	}

	void print() {
		std::cout << id << ": " << name << '\n';
	}
};

int main() {
	Person john("John Doe");
	Person jane("Jane Doe");
	Person clone = john;

	john.print();
	clone.print();

	clone = jane;

	jane.print();
	clone.print();
}
